#Bug with colSums in regressionestimator

library(sampling)

Xs=cbind(
c(1,1,1,1,1,0,0,0,0,0),
c(0,0,0,0,0,1,1,1,1,1),
c(1,2,3,4,5,6,7,8,9,10))

piks=rep(0.2,times=10)

t=c(24,26,280)

q=c(0,rep(1,times=9))

q[q==0]

regressionestimator(Xs,piks,t)

#regressionestimator fails if there is
# only one distance defined as 0
regressionestimator(Xs,piks,t,q)

"regressionestimator_2"=
function (Xs, piks, tot, q = rep(1, times = length(piks))) 
{
    library(MASS)
    tol = .Machine$double.eps
    n = length(piks)
    np = length(Xs)
    p = np/n
    Xs = matrix(Xs, n, p)
    Xs1 = Xs[q != 0, ]
    piks1 = piks[q != 0]
    q1 = q[q != 0]
    if (length(piks1) != n) 
        if (length(piks1) < n-1)
            t1 = tot - colSums((Xs/piks)[q == 0, ])
        else t1 = tot - (Xs/piks)[q == 0, ]
    else t1 = tot
    w = 1/piks1
    tc1 = c(t(w) %*% Xs1)
    A = t(Xs1 * q1 * w) %*% Xs1
    g1 = 1 + q1 * c(Xs1 %*% ginv(A, tol) %*% (t1 - tc1))
    g = rep(1, times = n)
    g[q != 0] = g1
    g
}

regressionestimator_2(Xs,piks,t)
g=regressionestimator_2(Xs,piks,t,q)

checkcalibration(Xs,piks,t,g)
